//=============================================================================
// UNR_Saver.
//=============================================================================
class UNR_Saver expands Info Config(Unreallity);

struct sPlayerData
{
	// General User Info.
	var string UserID;
	var string UserName;
	
	// Level User Info.
	var byte LVL,Rank;
	var int EXP, MinEXP;
	var int StatPoints;
	var byte Strength, Dexterity, Power;
	
	// Other User Info.
	var int BlueCrystal, RedCrystal;
};
var() config Array<sPlayerData> PlayerData;
const SaveInterval=60.0f;

final function SavePlayer(UNR_Classes Player)
{
	local int I;
	
	if(UNR_PRI(Player.PlayerReplicationInfo).UserID=="") return;
	else if(!RetrieveData(UNR_PRI(Player.PlayerReplicationInfo).UserID,I))
	{ Array_Insert(PlayerData,I); PlayerData[I].UserID=UNR_PRI(Player.PlayerReplicationInfo).UserID; }
	
	PlayerData[I].UserName		= Player.GetHumanName();
	
	PlayerData[I].LVL			= Player.LVL;
	PlayerData[I].Rank			= Player.Rank;
	PlayerData[I].EXP			= Player.EXP;
	PlayerData[I].MinEXP		= Player.MinEXP;
	PlayerData[I].StatPoints	= Player.StatPoints;
	PlayerData[I].Strength		= Player.Strength;
	PlayerData[I].Dexterity		= Player.Dexterity;
	PlayerData[I].Power			= Player.Power;
	
	PlayerData[I].BlueCrystal	= Player.BlueCrystal;
	PlayerData[I].RedCrystal	= Player.RedCrystal;
	
	Player.ClientMessage("[ACCOUNT SAVED]",'Pickup');
	SaveConfig();
}

final function LoadPlayer(UNR_Classes Player)
{
	local int I;
	
	if(UNR_PRI(Player.PlayerReplicationInfo).UserID=="") return;
	else if(!RetrieveData(UNR_PRI(Player.PlayerReplicationInfo).UserID,I)) return;
	
	Player.LVL					= PlayerData[I].LVL;
	Player.Rank					= PlayerData[I].Rank;
	Player.EXP					= PlayerData[I].EXP;
	Player.MinEXP				= PlayerData[I].MinEXP;
	Player.StatPoints			= PlayerData[I].StatPoints;
	Player.Strength				= PlayerData[I].Strength;
	Player.Dexterity			= PlayerData[I].Dexterity;
	Player.Power				= PlayerData[I].Power;
	
	Player.BlueCrystal			= PlayerData[I].BlueCrystal;
	Player.RedCrystal			= PlayerData[I].RedCrystal;
	
	Player.HandleModifiers(0);
	Player.Health=Player.MaxHealth;
	Player.Shield=Player.MaxShield;
	Player.Armor=Player.MaxArmor;
	
	Player.ClientMessage("[ACCOUNT LOADED]",'Pickup');
}

final function bool RetrieveData(string PlayerID, out int I)
{
	For(I=0; I<Array_Size(PlayerData); I++)
	if(PlayerData[I].UserID==PlayerID) Break;
	return (I!=Array_Size(PlayerData));
}

auto state Idle
{
Begin:
	Sleep(SaveInterval);
	SaveConfig();
	Goto'Begin';
}

defaultproperties
{
				PlayerData(0)=(UserID="4VCTU9V2",Username="Bleeder91<NL>",LVL=100,Exp=992213,StatPoints=100,Strength=37,Dexterity=13,Power=6,BlueCrystal=7)
				PlayerData(1)=(UserID="NDDMJ699",Username="Player",Strength=5,Dexterity=3,Power=2)
}
